'FFSubmenu=Bilderlisten
'FFName=Bilder sammeln

' ********************************************************************
' Bildersammeln.vbs (Skript fr FixFoto)
' Funktion:	Skript zum Erfassen gedroppter Dateien
'
' Copyright Harald Maeckler, Dsseldorf 2013
'
' Version 1.07 vom 29.03.2016	- Skript-URL gem Forenberarbeitung gendert
' Version 1.06 vom 15.02.2014	- Ablageort gendert (jetzt Stand.Temp-Ordner)
'								- Anzeige der Bedienoberflche, auch wenn noch keine Bilder abgelegt wurden
' Version 1.05 vom 18.03.2013	- 'Liste anzeigen' hinzugefgt
'									(Vorraussetzung: mindestens FF 3.40.70)
' Version 1.04 vom 14.03.2013	- Duplikate werden nicht mehr in die gewhlte Liste bertragen
' Version 1.03 vom 13.03.2013	- Texte gendert
'								- Fehler bei Dateien, die keine Bilder sind, beseitigt
'									(Problem mit 0 Byte-Datei)
' Version 1.02 vom 11.03.2013	- SkriptUrl gendert weil das Skript jetzt im Zubehrbereich
'									unter Skipte -> Bilderlisten zu finden ist
'								- Verknpfung wird jetzt auch im SendTo-Ordner erstellt
'								- Duplikate werden gesperrt
'								- Angabe wie viele Bilder in der gewhlten Liste vorhanden sind
'								- Lschen des Inhalts der ausgewhlten Liste mglich
'								- Anlegen einer neuen Liste mglich
' Version 1.01 vom 09.03.2013	- Weiterentwicklung
'								- u.a. bei Drag & Drop mehrere Dateien annehmen
' Version 1.00 vom 06.03.2013	- Betaversion
' ********************************************************************

Option Explicit

'Skriptname
Dim SkriptName
const Skript = "Bildersammeln"

'Updatekonstanten und Variable
const SkriptVersion = "1.07"
const SkriptURL = "http://www.ffsf.de/resources/bilder-sammeln.140/"
Dim UrlVersion,UrlV_Zahl,SkriptV_Zahl,SkriptEnde

'Objekte
Dim objFS,WshShell
Set objFS = CreateObject("Scripting.FileSystemObject")
Set WshShell = CreateObject("WScript.Shell")

'Lschroutine
Dim TempFile,SkriptKill	 : SkriptKill = false

'Allgemeine Deklarationen
Dim Anzeige,Antwort,Abbruch : Abbruch = false
const azt = 2	'Anzeigezeit in sec.

Const ForReading = 1, ForWriting = 2, ForAppending = 8
Const BildFilter = ":BMP:JP2:JPG:PNG:TIF:JPEG:"
Dim Fehler  : Fehler = false
Dim FixFoto : FixFoto = false
Dim flagZeigen : flagZeigen = false
Dim objFile,Sammeldatei,Sammlung
Dim strDesktop,strSendTo,strLinkD,strLinkS
Dim G_Liste
Dim anzBges,anzBneu,anzDneu,anzBliste
'------------------------------------------------------------------------
Sammeldatei = objFS.GetSpecialFolder(2) & "\Sammlung.txt"
call Drop

if FixFoto then call main

Set objFS = nothing
Set WshShell = nothing
'------------------------------------------------------------------------
Sub Drop
'gedroppte Bilder werden erkannt und abgespeichert
Dim objArgs,Namenssammlung,SammelArray,element,strExtension,Bild,S_Datei,n,msg,VerweisListe
Dim anz_Duplikat : anz_Duplikat = 0

on error resume next
	Set objArgs = WScript.Arguments
	for n = 0 to objArgs.Count - 1
		if len(Namenssammlung) = 0 then
			Namenssammlung = objArgs(n)
		else
			Namenssammlung = Namenssammlung & vbNewLine & objArgs(n)
		end if
	Next

	Set objFile = objFS.GetFile(WScript.Arguments(0))

	if err > 0 then
		Fehler = true
		if err = 500 then
			FixFoto = true
		elseif err = 9 then
			call TextlistenCheck
			WshShell.Popup "Es wurde(n) bisher" & vbNewLine & anzBges & " Bild(er) gesammelt.",azt,"Hinweis",vbInformation
		else
			WshShell.Popup "Kein Bild erkannt!",azt,"Hinweis",vbInformation
		end if
	end if
on error goto 0

if Fehler then
	Fehler = false : exit sub
end if

'prfen ob es sich um ein neues, bisher in der Sammelliste nicht abgelegtes Bild handelt und ggf. abspeichern

if objFS.FileExists(Sammeldatei) then
	Set S_Datei = objFS.OpenTextFile(Sammeldatei,ForReading)
	VerweisListe = S_Datei.ReadAll
	S_Datei.Close
end if

Set S_Datei = objFS.OpenTextFile(Sammeldatei,ForAppending,True)
	anzBneu = 0
	SammelArray = split(Namenssammlung,vbNewLine)
	for each element in SammelArray
		Set objFile = objFS.GetFile(element)
		Bild = objFile.Path
		strExtension = ucase(objFS.GetExtensionName(Bild))
		if instr(ucase(Bild),ucase("\AppData\")) = 0 and strExtension <> "" and instr(BildFilter,":" & strExtension & ":") > 0 then
			if instr(VerweisListe,Bild) = 0 then	'kein Duplikat
				S_Datei.WriteLine Bild
				anzBneu = anzBneu +1
			else
				anz_Duplikat = anz_Duplikat +1
			end if
		end if
	next
S_Datei.Close

Set S_Datei = objFS.GetFile(Sammeldatei)
if S_Datei.size = 0 then
	objFS.DeleteFile Sammeldatei,true
	anzBneu = 0 : anzBges = 0
end if

if anzBneu = 0 then
	if anz_Duplikat = 0 then
		msg = "Kein Bild erkannt!"
	else
		msg = "Duplikat(e)!"
	end if
elseif anzBneu = 1 then
	msg = "1 Bild erkannt in " & vbNewLine &  n & " Datei(en)"
else
	msg = anzBneu & " Bilder erkannt in " & vbNewLine & n & " Dateien"
end if
if anz_Duplikat > 0 and anzBneu > 0  then msg = msg & " incl." & vbNewLine & anz_Duplikat & " Duplikat(e)"

WshShell.Popup msg,azt,"Hinweis",vbInformation

End Sub
'------------------------------------------------------------------------
Sub main
Dim ListArray,element,N_Liste
Dim flagAblage : flagAblage = false

if objFS.FileExists(FF_GetScriptPath & "\" & Skript & ".vbs") then
	SkriptName = FF_GetScriptPath & "\" & Skript & ".vbs"
elseif objFS.FileExists(FF_GetScriptPath & "\" & Skript & ".vbe") then
	SkriptName = FF_GetScriptPath & "\" & Skript & ".vbe"
else
	msgbox "Das Skript wurde umbenannt!",vbCritical,"Abbruch"
	exit sub
end if

strDesktop = WshShell.SpecialFolders("Desktop")
strSendTo = WshShell.SpecialFolders("SendTo")
strLinkD = strDesktop & "\Bilder sammeln.lnk"
strLinkS = strSendTo & "\Bilder sammeln.lnk"
if not objFS.FileExists(strLinkD) or not objFS.FileExists(strLinkS) then call IconAbfrage
if Abbruch then exit sub

if len(FF_IListGetLists) = 0 then
	msgbox "Es muss mindestens eine Bilderliste angelegt sein!",vbCritical,"Abbruch"
	exit sub
end if

call TextlistenCheck

if anzBges = 0 and not flagZeigen then
	msgbox "Es wurden noch keine Bilder gesammelt!",vbInformation,"Hinweis"
end if

'** Start Dialog Bildsammler **
FF_AddDialog "Bildsammler",163,96
FF_AddControl "Bildsammler","Bilderliste als Ablageort whlen","GROUP",5,5,151,54
FF_AddControl "Bildsammler","Abbruch","BUTTON",79,79,33,11
FF_AddControl "Bildsammler","&delete","BUTTON",18,18,1,1
FF_AddControl "Bildsammler","|","STATIC",18,79,22,11
FF_SetControlStyle "Bildsammler","|",1
FF_AddControl "Bildsammler","Liste","COMBO",11,19,138,10
FF_AddControl "Bildsammler","?","BUTTON",5,79,11,11
FF_AddControl "Bildsammler","Bilder ablegen","BUTTON",114,79,42,11
FF_AddControl "Bildsammler","Update","BUTTON",42,79,33,11
FF_AddControl "Bildsammler","||","STATIC",8,64,144,10
FF_SetControlStyle "Bildsammler","||",1
FF_AddControl "Bildsammler","|||","STATIC",13,32,116,10
FF_AddControl "Bildsammler","Listeninhalt lschen","BUTTON",53,44,54,11
FF_AddControl "Bildsammler","Neue Liste","BUTTON",109,44,42,11
FF_AddControl "Bildsammler","Liste anzeigen","BUTTON",9,44,42,11
'** End Dialog Bildsammler **

ListArray = split(FF_IListGetLists,vbNewLine)
for each element in ListArray
	FF_SetControl "Bildsammler","Liste",element
next

for each element in ListArray
	if FF_IListGetCurrentList = element then
		FF_SetControl "Bildsammler","Liste",element
		exit for
	end if
next

anzBliste = FF_IListGetCount(FF_GetControl("Bildsammler","Liste"))
if anzBliste = 0 then FF_EnableControl "Bildsammler","Listeninhalt lschen", false
if anzBges   = 0 then FF_EnableControl "Bildsammler","Bilder ablegen", false

'Tooltips
if Version_OK("3.30.06") then
	FF_SetControlTooltip "Bildsammler","Listeninhalt lschen", "" &_
						 "Alle Bilder in der ausgewhlten Liste" & vbNewLine & _
						 "werden nach einer Sicherheitsabfrage gelscht."
	FF_SetControlTooltip "Bildsammler","Neue Liste", "" &_
						 "Es wird eine neue, leere Liste" & vbNewLine & "mit vorgebbarem Namen angelegt."
	FF_SetControlTooltip "Bildsammler","?", "" &_
						 "Anzeige der Kurzbeschreibung als PDF-Datei," & vbNewLine & _
						 "vorausgesetzt es ist ein PDF-Reader installiert."
	FF_SetControlTooltip "Bildsammler","Update", "" &_
						 "Prfung ob eine neue Version vorliegt."
	FF_SetControlTooltip "Bildsammler","Abbruch", "" &_
						 "Das Skript wird wieder beendet."
	FF_SetControlTooltip "Bildsammler","Bilder ablegen", "" &_
						 "Gesammelte Bilder werden in die angezeigte" & vbNewLine & _
						 "Bilderliste bertragen."
	FF_SetControlTooltip "Bildsammler","Liste anzeigen", "" &_
						 "Die ausgewhlte Liste wird angezeigt"
end if

if not Version_OK("3.40.70") then FF_EnableControl "Bildsammler","Liste anzeigen",false
if Version_OK("3.40.52") then FF_SetTooltipDelay 3000
FF_ActivateControl "Bildsammler","&delete"
FF_SetDialogTimer "Bildsammler", 100

Do
	Select Case FF_ShowDialog ("Bildsammler")

	Case "TIMER"
		FF_SetControl "Bildsammler" ,"|||","Die gewhlte Liste enthlt " & anzBliste & " Bild(er)"
		FF_SetControl "Bildsammler" ,"||",anzBges & "  Bild(er) knnen der gewhlte Liste hinzugefgt werden"
		FF_SetControl "Bildsammler" ,"|", "V " & Skriptversion
		FF_SetDialogTimer "Bildsammler", 0
	Case "&delete"
		Antwort = msgbox("Soll das Skript " & objFS.GetFileName(Skriptname) & vbNewline & _
						 "wirklich gelscht werden?", _
						 vbYesNo + vbQuestion,"Sicherheitsabfrage")
		if Antwort = vbYes then
			SkriptKill = true
			exit do
		end if
	Case "Liste"
		anzBliste = FF_IListGetCount(FF_GetControl("Bildsammler","Liste"))
		if anzBliste = 0 then 
			FF_EnableControl "Bildsammler","Listeninhalt lschen", false
		else
			FF_EnableControl "Bildsammler","Listeninhalt lschen", true
		end if
		FF_SetControl "Bildsammler" ,"|||","Die gewhlte Liste enthlt " & anzBliste & " Bild(er)"
	Case "Liste anzeigen"
		FF_IListShow FF_GetControl("Bildsammler","Liste")
	Case "Listeninhalt lschen"
		G_Liste = FF_GetControl("Bildsammler","Liste")
		Antwort = msgbox ("Sollen wirklich alle Bilder in der Liste" & vbNewLine &_
						  "   '" & G_Liste & "'" & vbNewLine &_
						  "gelscht werden?", vbQuestion + vbYesNo,"Sicherheitsabfrage")
		if Antwort = vbYes then
			do while FF_IListGetCount(G_Liste) > 0
				FF_IListDeleteIndex G_Liste,0
			loop
			FF_IListUpdate G_Liste
			anzBliste = 0
			FF_SetControl "Bildsammler" ,"|||",anzBliste & " Bild(er) enthlt die ausgewhlte Liste"
			FF_EnableControl "Bildsammler","Listeninhalt lschen", false
		end if
	Case "Neue Liste"
		N_Liste = InputBox("Name der neuen Liste?","Neue Liste","")
		if len(N_Liste) > 0 then
			if instr(ucase(vbNewLine & FF_IListGetLists & vbNewLine),ucase(N_Liste)) > 0 then
				msgbox "Die Liste '" & N_Liste & "' gibt es bereits!",vbInformation,"Hinweis"
			else
				FF_IListCreate N_Liste
				G_Liste = N_Liste : anzBliste = 0
				FF_SetControl "Bildsammler","Liste",G_Liste
				FF_SetControl "Bildsammler","Liste",G_Liste
				FF_SetControl "Bildsammler" ,"|||",anzBliste & " Bild(er) enthlt die ausgewhlte Liste"
				FF_EnableControl "Bildsammler","Listeninhalt lschen", false				
			end if
		end if
	Case"?"
		Anzeige = """" & FF_GetScriptPath & "\MeckiScript\BildSammlung\Bildersammlung.pdf" & """"
		on error resume next
		WshShell.Run Anzeige,1,false
		if err <> 0 then
			msgbox "Die Kurzbeschreibung konnte nicht als PDF-Datei geffnet werden." & vbNewLine & _
				   "Die Datei ist gelscht oder es ist kein PDF-Reader installiert (?)." & vbNewLine & vbNewLine &_
				   "Ersatzweise erfolgt eine Textanzeige!",vbExclamation,"Hinweis"
			err.clear
			
			if not KBvorhanden then	call KurzbeschreibungLesen
			if KBvorhanden then
				call KurzbeschreibungAnzeigen
			else
				msgbox "Keine Kurzbeschreibung gefunden!",vbExclamation,"Meldung"
			end if
			
		end if
		on error GoTo 0
	Case"Update"
		SkriptEnde = false
		call Update
		if SkriptEnde then exit do
	Case "Bilder ablegen"
		G_Liste = FF_GetControl("Bildsammler","Liste")
		flagAblage = true
		exit do
	Case "Abbruch","CANCEL"
		exit do
	Case Else
	End Select
loop

FF_CloseDialog ("Bildsammler")

if flagAblage then call Ablage
if SkriptKill then call KillSkript

End Sub
'------------------------------------------------------------------------
Sub IconAbfrage

'** Start Dialog Verknpfung **
FF_AddDialog "Verknpfung",104,98
FF_AddControl "Verknpfung","Soll die Verknpfung","STATIC",23,1,54,10
FF_SetControlStyle "Verknpfung","Soll die Verknpfung",1
FF_AddControl "Verknpfung","Icon","IMAGE",35,16,32,32
FF_AddControl "Verknpfung","Bilder sammeln","STATIC",24,48,54,10
FF_SetControlStyle "Verknpfung","Bilder sammeln",1
FF_AddControl "Verknpfung","auf dem Desktop und im","STATIC",6,61,90,10
FF_SetControlStyle "Verknpfung","auf dem Desktop und im",1
FF_AddControl "Verknpfung","Ja","BUTTON",7,85,28,11
FF_AddControl "Verknpfung","Nein","BUTTON",37,85,28,11
FF_AddControl "Verknpfung","Abbruch","BUTTON",67,85,28,11
FF_AddControl "Verknpfung","Ordner SendTo angelegt werden?","STATIC",6,70,90,10
FF_SetControlStyle "Verknpfung","Ordner SendTo angelegt werden?",1
'** End Dialog Verknpfung **

FF_SetControl "Verknpfung" ,"Icon",FF_GetScriptPath & "\MeckiScript\BildSammlung\ImageCollection.png"

Do
	Select Case FF_ShowDialog ("Verknpfung")
	Case "Ja"
		call Verknuepfung
		if objFS.FileExists(strLinkD) and objFS.FileExists(strLinkS) then
			msgbox "Verknpfungen auf dem Desktop" & vbNewLine & "und im SendTo-Ordner sind angelegt!" & vbNewLine & vbNewLine &_
			   	"Jetzt mssen erst einmal extern Bilder gesammelt werden" & vbNewLine &_
			   	"- per 'Drag and Drop'auf die Verknpfung" & vbNewLine &_
			   	"- per 'Senden an' ber das Kontextmen" & vbNewLine &_
			   	"- per 'Copy and Paste' mit Fokus auf die Verknpfung" & vbNewLine & vbNewLine &_
			   	"FixFoto kann dafr geschlossen werden!",vbInformation,"Hinweis"
		else
			msgbox "Schwerer Fehler!" & vbNewLine &_
				   "Die Verknpfung konnte nicht angelegt werden.",vbExclamation,"Abbruch"
		end if
		Abbruch = true
		exit do
	Case "Nein"
		flagZeigen = true
		exit do
	Case "Abbruch","CANCEL"
		Abbruch = true
		exit do
	Case Else
	End Select
loop

FF_CloseDialog ("Verknpfung")

End Sub
'------------------------------------------------------------------------
Sub Verknuepfung
'erstellen einer Verknpfung auf dem Desktop

Dim strIcon,oShellLink
strIcon = FF_GetScriptPath & "\MeckiScript\BildSammlung\ImageCollection.ico"

if not objFS.FileExists(strLinkD) then
	set oShellLink = WshShell.CreateShortcut(strLinkD)
	oShellLink.TargetPath = SkriptName
	oShellLink.IconLocation = strIcon
	'	oShellLink.WindowStyle = 1
	'	oShellLink.Hotkey = "CTRL+SHIFT+F"
	oShellLink.Description = "fr FixFoto Bilder sammeln"
	oShellLink.WorkingDirectory = FF_GetScriptPath
	oShellLink.Save
end if

if not objFS.FileExists(strLinkS) then
	set oShellLink = WshShell.CreateShortcut(strLinkS)
	oShellLink.TargetPath = SkriptName
	oShellLink.IconLocation = strIcon
	'	oShellLink.WindowStyle = 1
	'	oShellLink.Hotkey = "CTRL+SHIFT+F"
	oShellLink.Description = "fr FixFoto Bilder sammeln"
	oShellLink.WorkingDirectory = FF_GetScriptPath
	oShellLink.Save
end if

End Sub
'------------------------------------------------------------------------
Function Version_OK(MinVersion)
dim VersNr

 VersNr=split(MinVersion,".")
 Version_OK=FF_GetMajor * 1000 + FF_GetMinor + FF_GetBuild / 1000 >=_
     		VersNr(0) * 1000 + VersNr(1) + VersNr(2) / 1000

End Function
'------------------------------------------------------------------------
Sub TextlistenCheck
Dim S_Datei,Barray
anzBges = 0

'Sammeldatei auslesen und prfen wieviele Bilder enthalten sind

if objFS.FileExists(Sammeldatei) then

	Set S_Datei = objFS.GetFile(Sammeldatei)
	if S_Datei.size = 0 then
		objFS.DeleteFile Sammeldatei,true
		anzBges = 0
		exit sub
	end if

	Set S_Datei = objFS.OpenTextFile(Sammeldatei,ForReading,True)
		Sammlung = S_Datei.ReadAll
	S_Datei.Close
	
	if len(Sammlung) = 0 then
		anzBges = 0
	else
		Barray = split(Sammlung,vbNewLine)
		anzBges = ubound(Barray)
	end if
else
	anzBges = 0
end if

End Sub
'------------------------------------------------------------------------
Sub Ablage
'Bilder aus der Sammeldatei werden in der ausgewhlten Bilderliste abgelegt

Dim S_Array,element,Anz,m,BilderInListe,msg
Dim anzBinL : anzBinL = 0		'Anzahl Bilder, die bertragen wurden
Dim anzDinL : anzDinL = 0		'Anzahl Duplikate in der Sammelliste

'in der gewhlten Bilderliste vorhanden Bilder sammeln
for m = 0 to FF_IListGetCount(G_Liste) -1
	if len(BilderInListe) = 0 then
		BilderInListe = FF_IListGetFile(G_Liste,m)
	else
		BilderInListe = BilderInListe & vbNewLine & FF_IListGetFile(G_Liste,m)
	end if
next

'Bilder aus der Sammeldatei in die ausgewhlte Bilderliste bertragen
S_Array = split(Sammlung,vbNewLine)
for each element in S_Array
	if len(element) > 0 then
		if instr(BilderInListe,element) = 0 then
			FF_IListInsertFile G_Liste,element,-1
			anzBinL = anzBinL +1
		else
			anzDinL = anzDinL +1
		end if
	end if
next

FF_IListUpdate G_Liste
FF_IListSave G_Liste
objFS.DeleteFile Sammeldatei,true

if anzBinL = 0 then
	msg =	"Es wurde kein Bild bertragen, da es sich bei den" & vbNewLine &_
			"gesammelten Bildern um Duplikate handelt."
else
	msg = 	"Es wurde(n) " & anzBinL & " Bild(er) in die Bilderliste" & vbNewLine &_
			"'" & G_Liste & "' bertragen."
	if anzDinL > 0 then
		msg = 	msg & vbNewLine & vbNewLine &_
				anzDinL & " in der Sammlung enthaltene(s) Duplikat(e)" & vbNewLine &_
				"wurde nicht bertragen."
	end if
end if

msgbox msg,vbInformation,"Hinweis"

End Sub
'------------------------------------------------------------------------
'************************************************************************
'Lsch-Funktion
'************************************************************************
Sub KillSkript
'Skript mit allen Komponenten entfernen

Dim SPfad

'### FixFotoScript.ini bereinigen
TempFile = FF_GetFFPathEx(1) & "\FixFotoScript.ini"
if objFS.FileExists(TempFile) then
	call IniBereinigung
	if Abbruch then exit sub
else
	msgbox 	"Die Datei FixFotoScript.ini konnte nicht gefunden werden." & vbNewLine & _
			"Der Lschvorgang wird abgebrochen!",vbExclamation,"Hinweis"
	exit sub
end if

'### zip-Archiv auf Wunsch sichern, dann lschen
TempFile = FF_GetScriptPath & "\" & objFS.GetBaseName(Skriptname) & ".zip"
if objFS.FileExists(TempFile) then
	Antwort = msgbox("Soll das Archiv " & objFS.GetBaseName(Skriptname) & ".zip" & _
			 " gesichert werden?",vbYesNo + vbQuestion,"Sicherheitskopie")
	if Antwort = vbYes then
		SPfad = FF_EnterPath(true,"Wo soll die Sicherheitskopie angelegt werden?")
		if SPfad = "" then
			msgbox "Das Lschen des Skripts wird abgebrochen!",vbExclamation,"Hinweis"
			exit sub
		end if
		SPfad = SPfad & "\" & objFS.GetBaseName(Skriptname) & ".zip"
		objFS.CopyFile Tempfile, SPfad, true
	end if
	objFS.DeleteFile TempFile,true
end if

'### Skriptdatei lschen
objFS.DeleteFile Skriptname,true

'### erzeugte Links lschen
if objFS.FolderExists(strLinkD) then objFS.DeleteFolder strLinkD,true
if objFS.FolderExists(strLinkS) then objFS.DeleteFolder strLinkS,true

'### erzeugten Ordner lschen
TempFile = FF_GetScriptPath & "\MeckiScript\BildSammlung"
if objFS.FolderExists(TempFile) then objFS.DeleteFolder TempFile,true

'### Fertigmeldung
msgbox "Das Skript" & objFS.GetFileName(Skriptname) & vbNewLine & "wurde mit allen Komponenten gelscht!" & vbNewLine & _
	   "Es wird empfohlen die 'Automatische Skriptkonfiguration' aufzurufen.",vbExclamation,"Hinweis"

End Sub
'------------------------------------------------------------------------
Sub IniBereinigung
'FixFotoScript.ini - Bereinigung

Dim Zeile, zNr,Anfang, Ende, DateiTmp, ZielZeile, tmpString

DateiTmp =  FF_GetFFPathEx(1) & "\FixFotoScript.tmp"

'### Wo befindet sich der Eintrag zum Skript?
Set Zeile = objFS.OpenTextFile(TempFile, ForReading)

zNr = 0
do Until Zeile.AtEndOfStream
	tmpString = Zeile.ReadLine
	zNr = zNr + 1
	if tmpString = "[Script]" then Anfang = zNr
	if tmpString = "File=.\" & objFS.GetFileName(Skriptname) then
		Ende = zNr
		exit do	
	end if
loop 
Zeile.Close

if Ende <= Anfang then
	msgbox 	"Die Datei FixFotoScript.ini konnte nicht bereinigt werden." & vbNewLine & _
		"Der Lschvorgang wird abgebrochen!",vbExclamation,"Hinweis"
	Abbruch = true
	exit sub
end if

'### Zeilen ohne skriptbezogene Zeilen in DateiTmp bertragen
Set Zeile = objFS.OpenTextFile(TempFile, ForReading)
Set ZielZeile  = objFS.CreateTextFile(DateiTmp, True)

zNr = 0
do Until Zeile.AtEndOfStream
	tmpString = Zeile.ReadLine
	zNr = zNr + 1
	if zNr < Anfang or zNr > Ende then
		ZielZeile.WriteLine tmpString
	end if
loop 

Zeile.Close
ZielZeile.Close

'### Umkopieren von DateiTmp nach FixFotoScript.ini (TempFile)
objFS.CopyFile DateiTmp, TempFile, True
objFS.DeleteFile (DateiTmp)

End Sub
'************************************************************************
'Update-Funktion
'************************************************************************
Sub Update
Dim Antwort

call Versionsermittlung_url

if not Abbruch then
	SkriptV_Zahl = Replace(SkriptVersion,".","") *1
	
	if UrlV_Zahl = SkriptV_Zahl then
		msgbox "Die Version " & SkriptVersion & " ist aktuell!",vbInformation,"Versionsmeldung"
	elseif SkriptV_Zahl < UrlV_Zahl then
		Antwort = msgbox("Die Skriptversion " & SkriptVersion & " ist nicht mehr aktuell!" & vbNewLine &_
				"Es steht die Version " & UrlVersion & " zum Download bereit." & vbNewLine & vbNewLine & _
				"Soll die Downloadseite aufgerufen werden?",vbQuestion + vbYesNo,"Versionsmeldung")
		if Antwort = vbYes then
			on error resume next
			WshShell.Run SkriptUrl,1,false
			if err <> 0 then
				msgbox "Die Downloadseite wurde nicht gefunden!",vbExclamation,"Hinweis"
			else
				SkriptEnde = true
			end if
			on error goto 0
		end if
	else
		msgbox 	"Es liegt ein Fehler in den Versionsangaben vor." & vbNewLine &_
				"Die Skriptversion " & SkriptVersion & " ist grer als die auf" & vbNewLine &_
				"der Downloadseite angegebene Version " & UrlVersion & ".",vbInformation,"Fehlermeldung"
	end if
end if

End Sub
'------------------------------------------------------------------------
Sub Versionsermittlung_url

Dim Inhalt,Start,Zeit,pos1,pos2,n
Dim xml, Fehler
Fehler = false

on error resume next
Set xml = CreateObject("Microsoft.XMLHTTP")
xml.Open "Get",SkriptUrl,false
xml.Send

Inhalt = xml.responseText

if err > 0 then
	Fehler = true
else
	'Version suchen und anzeigen
	pos1 = instr(Inhalt,"Version:")
	if pos1 > 0 then
	
		pos2 = instr(pos1 ,Inhalt,"<br")
		if pos2 > 0 then
			UrlVersion = trim(mid(Inhalt,pos1,pos2-pos1))
		else
			Fehler = true
		end if
	else
		Fehler = true
	end if
end if

Set xml = nothing

if Fehler then
	msgbox  "Die Versionsangabe wurde nicht gefunden!" & vbNewLine &_
			"Mglicherweise funktioniert der Internetaufruf nicht." & vbNewLine & vbNewLine & _
			"Am besten nochmal probieren!",vbExclamation,"Fehlermeldung"
	Abbruch = true
	exit sub
end if

'Version als Zahl
pos1 = instr(UrlVersion," ")
if pos1 = 0 then pos1 = 7
UrlVersion = trim(mid(UrlVersion,pos1+1))
UrlV_Zahl = Replace(UrlVersion,".","") *1

End Sub
'------------------------------------------------------------------------
'************************************************************************
